import java.io.*;
import java.lang.*;
import java.lang.Math;
import java.util.*;
import java.util.Date;
import java.sql.*;
import javax.servlet.*;
import javax.servlet.http.*;

public class FacultySession extends Session{
    String Dir="/users/ug96/gsiva/6_sem/Bis/Bis_project/Java_codes/Html_files/";
	
    public void printPage(Connection Mycon,PrintWriter out,HttpServletRequest Req,String cook){
	// Read from the corresponding form and print back!!!
	try{
	    Integer form_no = new Integer(Req.getParameterValues("form_no")[0]);
	    switch(form_no.intValue()){
		case 0:
		    try{
		        Statement Stmt = Mycon.createStatement();
		        String query="select * from faculty where loginid='"+loginId+"'";
		        ResultSet result=Stmt.executeQuery(query);
		        if(result.next()){
			    // Write the alternate page for faculty
			    this.printRespectivePage(Dir+"Facoption.html",out);
			    this.printTypes(out,Mycon);
		        }
		        else{
		            this.printRespectivePage(Dir+"Facultyform.html",out);
		        }
		    }catch(SQLException e){}
		    break;
		case 3:
		    this.printRespectivePage(Dir+"Confirmation.html",out);
		    break;
		case 6:
		    this.printRespectivePage(Dir+"Approval.html",out);
		    break;
	    }
	} catch(NumberFormatException e){}
	  catch(FileNotFoundException e){}
	  catch(IOException e){}
    }


    public void printTypes(PrintWriter out,Connection Conn){
	String query,My_type;
	try{
	Statement Stmt1=Conn.createStatement();
	ResultSet types=Stmt1.executeQuery("select * from types");
	String s="";
	while(types.next()){
	    Statement Stmt2=Conn.createStatement();
	    query="select * from student_faculty where loginid='"+loginId+"' and type='"+types.getString(1)+"'";
	    ResultSet type=Stmt2.executeQuery(query);
	    System.out.println("I am here\n");	
	    if(type.next()){
		s+="<form method=post action=\"http://everest.cse.iitb.ernet.in:5030/servlet/Main\"> <center>";
		s+="<input type=hidden name=type value="+types.getString(1)+">";
		s+="<input type=hidden name=form_no value=4> <font size=5>";
		My_type=types.getString(1);
		s+="<input type=submit value="+My_type.toUpperCase()+">";
		s+="</font> </center> </form>";
	    }		    
	    Stmt2.close();
	}
	s+="</body></html>";
	out.println(s);
	}catch(SQLException e){} 
    }

    
    public void processData(HttpServletRequest Req,Connection Mycon,PrintWriter out){
	// Process the data from the corresponding form!!!
	try{
	    Integer form_no = new Integer(Req.getParameterValues("form_no")[0]);
	    switch(form_no.intValue()){
		case 3:
		    try{
	    		System.out.println("I in Process data");
		        this.insData(Req,Mycon);
		    }catch(SQLException e){}	
		    break;
		case 4:
	    	    this.search(Req,Mycon,out);
		    break;
		case 5:
	    		System.out.println("I in Process data");
		        this.printStudentInfo(Req,out);
		    break;
		case 6:
		    try{
	    		System.out.println("I in Process data");
		        this.changeStatus(Req,Mycon);
		    }catch(SQLException e){}	
		    break;
	    }
	} catch(NumberFormatException e){}
    }
    

    
    public void insData(HttpServletRequest Req,Connection Mycon)
    throws SQLException{
	try{
	    int newSerialNo=0;
	    String dno="";
	    Statement Stmt = Mycon.createStatement();	
	    String Name=checkQuote(Req.getParameterValues("name")[0]);
	    String Email=checkQuote(Req.getParameterValues("email")[0]);
	    String Stg="select dno from auth_table where login='"+loginId+"'";
	    ResultSet Dno=Stmt.executeQuery(Stg);
	    System.out.println(Stg);
	    if(Dno.next()){
	        dno=Dno.getString(1);
	    }
	    Stg="insert into faculty values('"+loginId+"','"+Name+"','"+dno+"','"+Email+"')";
	    System.out.println(Stg);
	    Stmt.executeUpdate(Stg);
	    Stmt.close();
	}catch(SQLException e){System.out.println("Unable to insert");}
    }
    
    public void changeStatus(HttpServletRequest Req,Connection Mycon)
    throws SQLException{
	try{
	    Statement Stmt = Mycon.createStatement();	
	    String Serialno=Req.getParameterValues("serialno")[0];
	    
	    // Send a mail to corresponding student !!!
	    String Stg="update thesis set status='y' where serialno='"+Serialno+"'";
	    System.out.println(Stg);
	    Stmt.executeUpdate(Stg);
	    Stmt.close();
	}catch(SQLException e){System.out.println("Unable to insert");}
    }
    
	
    
    public void printRespectivePage(String Filename,PrintWriter out)
    throws FileNotFoundException,IOException{
	// Open the file with name Filename and just print the contents of it!! 

	try{
	    System.out.println("I in printrespage and file name="+Filename);
            FileInputStream file = new FileInputStream(Filename);
	    InputStreamReader reader = new InputStreamReader(file);
	    BufferedReader input = new BufferedReader(reader);
	    String nextLine;
	    while((nextLine=input.readLine())!=null){
	        out.println(nextLine);
	    }
	    input.close();
	    reader.close();
	    file.close();
	} catch(FileNotFoundException e){System.out.println("File not found");}
    }

    public void search(HttpServletRequest req,Connection conn,PrintWriter out){
	String Login,Name,Roll,Dept,Guide,Type,Title,Kw1;
	int Year;
	try{
	    Statement stmt =conn.createStatement();
	    Login=loginId;
	    Date CurrDate=new Date();
	    Year=CurrDate.getYear()+1900;
	    Type=req.getParameterValues("type")[0];
	    String sear= "select students.sroll, students.sname, thesis.title,thesis.keyword1,thesis.keyword2,thesis.keyword3,thesis.keyword4,thesis.filename,thesis.status,thesis.serialno,thesis.abstract from student_faculty,students, thesis,student_thesis where student_faculty.sroll=students.sroll and ( student_faculty.loginid='"+Login+"' or student_faculty.co_loginid='"+Login+"') and student_faculty.type like '%"+Type+"%' and student_thesis.serialno=thesis.serialno and student_thesis.sroll=students.sroll and thesis.year='"+Year+"'";
	    System.out.println(sear);
	    ResultSet rset1=stmt.executeQuery(sear);
	    System.out.println("I in search!!!!  Login="+Login+"date="+Year+"Type="+Type);
	    gen_form(rset1,out,Type);
   	} catch(SQLException e){System.err.println("hi"+e);}
    }
		
    public void gen_form(ResultSet res,PrintWriter out,String Type){
      String sname,dname,file,dir,roll,title,filename,kw1,kw2,kw3,kw4,status;
      String serialno,str1="";
      String thesisDir="http://www.cse.iitb.ernet.in/~gsiva/thesis_files/";
	int i=0;
	Integer i1=new Integer(0);
	Random Myrandom=new Random();
	i=Myrandom.nextInt();
	out.println("<html> <body background=\"http://www.cse.iitb.ernet.in/~gsiva/green_pasture.gif\" text=yellow bgcolor=green link=\"#ffffff\"><head><h1><u><center>Students in "+Type+"</center></u></h1></head>");
	try{
	    while(res.next()){
		roll=res.getString(1);
		sname=res.getString(2);
		title=res.getString(3);
		kw1=res.getString(4);
		kw2=res.getString(5);
		kw3=res.getString(6);
		kw4=res.getString(7);
		status=res.getString(9);
		serialno=res.getString(10);
		String Abstract=res.getString(11);
		str1+="<form method=post action=\"http://everest.cse.iitb.ernet.in:5030/servlet/Main\">";
		str1+="<center>";
		str1+="<hr><font size=5>"+roll+"</font>"+" ";
		str1+="<font size=5>"+sname+"</font>"+" ";
		str1+="<font size=5>"+title+"</font>";
		str1+="</center>";
		str1+="<input type=hidden name=form_no value=5>";
		str1+="<input type=hidden name=roll value="+roll+">";
		str1+="<input type=hidden name=Type value="+Type+">";
		str1+="<input type=hidden name=title value=\""+title+"\">";
		str1+="<input type=hidden name=kw1 value=\""+kw1+"\">";
		str1+="<input type=hidden name=kw2 value=\""+kw2+"\">";
		str1+="<input type=hidden name=kw3 value=\""+kw3+"\">";
		str1+="<input type=hidden name=kw4 value=\""+kw4+"\">";
		str1+="<input type=hidden name=serialno value=\""+serialno+"\">";
		str1+="<input type=hidden name=Abstract value=\""+Abstract+"\">";
		str1+="<input type=hidden name=status value=\""+status+"\">";
		str1+="<br><center><font size=5>";
		str1+="<input type=submit value=\"Information regarding the thesis\">";
		str1+="</font></center></form>";
		}
	} catch(SQLException e){} 
	out.println(str1+"</body></html>");
    }
    String checkQuote(String initString){
	int beginindex=0,endindex=0;
	String returnString="";
	for(;;){
	    endindex=initString.indexOf("'",beginindex);
	    if(endindex==-1){
		returnString+=initString.substring(beginindex);
		break;
	    }
	    else{
		returnString+=initString.substring(beginindex,endindex)+"''";
		beginindex=endindex+1;
	    }
    	}
	return(returnString);
    }	

    public void printStudentInfo(HttpServletRequest req,PrintWriter out){
        String thesisDir="http://www.cse.iitb.ernet.in/~gsiva/thesis_files/";
	String str1 = "<html><body background=\"http://www.cse.iitb.ernet.in/~gsiva/green_pasture.gif\" text=\"yellow\" bgcolor=\"green\" link=\"#ff0000\"><head><h1><u><center>STUDENT INFORMATION</center></u></h1></head>";
	str1+="<form method=post action=\"http://everest.cse.iitb.ernet.in:5030/servlet/Main\">";
	str1+="<center>";
	str1+="<font size=5>";
	str1+="<br> Student Roll No :"+req.getParameterValues("roll")[0];
	str1+="<br> Thesis Type : "+req.getParameterValues("Type")[0];
	str1+="<br> Title of Thesis : "+req.getParameterValues("title")[0];
	str1+="<br> Key words : "+req.getParameterValues("kw1")[0]+","+req.getParameterValues("kw2")[0]+","+req.getParameterValues("kw3")[0]+","+req.getParameterValues("kw4")[0];
	String file=thesisDir+req.getParameterValues("roll")[0]+req.getParameterValues("Type")[0]+".ps";
	str1+="<br><a href=\""+file+"\"> Thesis</a><br>";
	str1+="<input type=hidden name=form_no value=6>";
	str1+="<input type=hidden name=serialno value="+req.getParameterValues("serialno")[0]+">";
	System.out.println("I here\n");
	System.out.println(req.getParameterValues("Abstract")[0]);
	str1+="<u>Abstract of the thesis</u><br>"+req.getParameterValues("Abstract")[0]+"<br>";
	System.out.println("I here1\n");
	String status=req.getParameterValues("status")[0];
	System.out.println("I here2\n");
	if(status.compareTo("y") != 0){
	     str1+="<input type=submit value=\"Approve thesis\">";
	}
	else{
	     str1+="The thesis has been approved.";
	}
	str1+="</font></center></form></body></html>";
	out.println(str1);
    }
}
