import java.io.*;
import java.util.*;
import java.sql.*;

import javax.servlet.*;
import javax.servlet.http.*;

public class QuerySession extends SearchSession{
Connection conn;
String Dir="/users/ug96/gsiva/6_sem/Bis/Bis_project/Java_codes/Html_files/";
    public QuerySession(Connection Mycon){
	conn = Mycon;
    }	

    public void processData(HttpServletRequest Req,Connection Mycon,PrintWriter out){
	// Process the data from the corresponding form!!!
	try{
	    Integer form_no = new Integer(Req.getParameterValues("form_no")[0]);
	    switch(form_no.intValue()){
		case 0:
		    try{	
		    this.printRespectivePage("Queries1.html",out);	
		    this.printTypes(out);
		    this.printRespectivePage("Queries2.html",out);	
		    } catch(FileNotFoundException e){}
		      catch(IOException e){}
		    break;
		case 1:
	    	    this.search(out,Req);
		    break;
		case 2:
	            this.printStudentInfo(Req,out);
		    break;
	    }
	} catch(NumberFormatException e){}
    }

    public void printTypes(PrintWriter out){
	try{
	Statement Stmt=conn.createStatement();
	ResultSet types=Stmt.executeQuery("select * from types");
	String s="<tr><td> <font size=5> Thesis Type </font> </td><td>";
	s+="<font size=5><select name=\"ttype\"><option selected value=\"\">None";
	while(types.next()){
		s+="<option value=\""+types.getString(1)+"\">"+types.getString(1);
	}
	s+="</select><br></font></td></tr>";
	out.println(s);
	} catch(SQLException e){}
   }	

    public void search(PrintWriter out, HttpServletRequest req){
	String Name,Roll,Dept,Guide,Year,Type,Title,Kw1;
	try{
	    Statement stmt =conn.createStatement();
	    Name=req.getParameterValues("name")[0];
	    Roll=req.getParameterValues("rollno")[0];
	    Dept=req.getParameterValues("dept")[0];
	    Guide=req.getParameterValues("gname")[0];
	    Year=req.getParameterValues("year")[0];
	    Type=req.getParameterValues("ttype")[0];
	    Kw1=req.getParameterValues("keyword1")[0];
	    Title=req.getParameterValues("title")[0];
	    String sear="select students.sroll, students.sname,students.saddress,students.semail,department.dname, thesis.title,thesis.type,thesis.filename, faculty.fname,faculty.femail,thesis.abstract,thesis.status from thesis,student_thesis,students,faculty,department,student_faculty where thesis.title like '%"+ Title +"%' and (keyword1 like '%"+ Kw1+"%' or keyword2 like '%"+Kw1+"%' or keyword3 like '%"+Kw1+"%' or Keyword4 like '%"+Kw1+"%') and thesis.year like '%"+Year+"%' and thesis.type like '%"+Type+"%' and (faculty.fname like '%"+Guide+"%' or faculty.loginid like '%"+Guide+"%') and (department.dno like '%"+Dept+"%' or department.dname like '%"+Dept+"%') and students.sname like '%"+Name+"%' and students.sroll like '%"+Roll+"%' and thesis.serialno=student_thesis.serialno and student_thesis.sroll=students.sroll and student_faculty.sroll=student_thesis.sroll and student_faculty.loginid=faculty.loginid and students.dno=department.dno "; 
		
	    ResultSet rset1=stmt.executeQuery(sear);
	    gen_form(rset1,out);
   	} catch(SQLException e){System.err.println("hi"+e);}
    }
		
    public void gen_form(ResultSet res,PrintWriter out){
      String sname,fname,dname,file,dir,address,email,roll,type,title,filename;
      String thesisDir="http://www.cse.iitb.ernet.in/~gsiva/thesis_files/";
      String str1="";
	int i=0;
	Integer i1=new Integer(0);
	Random Myrandom = new Random();
	i=Myrandom.nextInt();
	out.println("<html><body background=\"http://www.cse.iitb.ernet.in/~gsiva/green_pasture.gif\" text=yellow bgcolor=green link=#ffffff><head><h1><center><u>Search Results</u></center></h1></head>");
	try{
	    while(res.next()){
		roll=res.getString(1);
		sname=res.getString(2);
		address=res.getString(3);
		email=res.getString(4);
		dname=res.getString(5);
		title=res.getString(6);
		type=res.getString(7);
		fname=res.getString(9);
		String Abstract=res.getString(11);
		String status=res.getString(12);
		str1+="<form method=post action=\"http://everest.cse.iitb.ernet.in:5030/servlet/Query\">";
		str1+="<hr><font size=5>";
		str1+="<center>"+sname+","+title+","+type+"</center><br>";
		str1+="<input type=hidden name=roll value=\""+roll+"\">";
		str1+="<input type=hidden name=address value=\""+address+"\">";
		str1+="<input type=hidden name=fname value=\""+fname+"\">";
		str1+="<input type=hidden name=Abstract value=\""+Abstract+"\">";
		str1+="<input type=hidden name=email value=\""+email+"\">";
		str1+="<input type=hidden name=sname value=\""+sname+"\">";
		str1+="<input type=hidden name=dname value=\""+dname+"\">";
		str1+="<input type=hidden name=Type value=\""+type+"\">";
		str1+="<input type=hidden name=status value=\""+status+"\">";
		str1+="<input type=hidden name=title value=\""+title+"\">";
		str1+="<input type=hidden name=form_no value=2>";
		str1+="<center><input type=submit value=\"Information regarding the Student\">";
		str1+="</center></font></form>";
		}
	} catch(SQLException e){} 
	out.println(str1);
	out.println("</body></html>");
    }

	
    public void printStudentInfo(HttpServletRequest req,PrintWriter out){
        String thesisDir="http://www.cse.iitb.ernet.in/~gsiva/thesis_files/";
	String file=thesisDir+req.getParameterValues("roll")[0]+req.getParameterValues("Type")[0]+".ps";
	String str1 = "<html><body background=\"http://www.cse.iitb.ernet.in/~gsiva/green_pasture.gif\" text=\"yellow\" bgcolor=\"green\" link=\"#ff0000\"><head><h1><u><center>STUDENT INFORMATION</center></u></h1></head>";
	str1+="<center>";
	str1+="<font size=5>";
	str1+="<br> Student Name :"+req.getParameterValues("sname")[0];
	str1+="<br> Student Roll No :"+req.getParameterValues("roll")[0];
	str1+="<br> Thesis Type : "+req.getParameterValues("Type")[0];
	str1+="<br> Title of Thesis : "+req.getParameterValues("title")[0];
	str1+="<br> Name of Guide : "+req.getParameterValues("fname")[0];
	str1+="<br> Department : "+req.getParameterValues("dname")[0];
	str1+="<br> Email : "+req.getParameterValues("email")[0];
	str1+="<br> Address : "+req.getParameterValues("address")[0];
	str1+="<br><a href=\""+file+"\"> Thesis</a><br>";
	str1+="<u>Abstract of the thesis</u><br>"+req.getParameterValues("Abstract")[0]+"<br>";
	String status=req.getParameterValues("status")[0];
	if(status.compareTo("y") != 0){
	     str1+="The thesis has not been approved.";
	}
	else{
	     str1+="The thesis has been approved.";
	}
	str1+="</font></center></body></html>";
	out.println(str1);
    }

    public void printRespectivePage(String Filename,PrintWriter out)
    throws FileNotFoundException,IOException{
	// Open the file with name Filename and just print the contents of it!! 

	try{
	    System.out.println("I in printrespage and file name="+Filename);
            FileInputStream file = new FileInputStream(Dir+Filename);
	    InputStreamReader reader = new InputStreamReader(file);
	    BufferedReader input = new BufferedReader(reader);
	    String nextLine;
	    while((nextLine=input.readLine())!=null){
	        out.println(nextLine);
	    }
	    input.close();
	    reader.close();
	    file.close();
	} catch(FileNotFoundException e){System.out.println("File not found");}
    }
}
