import java.io.*;
import java.util.*;
import java.sql.*;
import javax.servlet.*;
import javax.servlet.http.*;

public class MainServlet extends HttpServlet implements SingleThreadModel{
    Connection Mycon;
    public void init(ServletConfig cfg)
    throws ServletException{
	try{
            DriverManager.registerDriver(new oracle.jdbc.driver.OracleDriver());
            Mycon=DriverManager.getConnection("jdbc:oracle:thin:@:1521:GEN","bikash","bikash");		
	}catch(SQLException e){System.out.println("Sorry JDBC not connecting");}
    }
    public void doPost(HttpServletRequest Req, HttpServletResponse Res)
    throws ServletException, IOException {
	    
	Res.setContentType("text/html");
	PrintWriter out = Res.getWriter();
	String form_no=Req.getParameterValues("form_no")[0];
	System.out.println("I here and current form no "+form_no);
	HttpSession hs = Req.getSession(true);
        Session ss = (Session)hs.getValue("mySession");
	String Id=hs.getId();
	if(form_no.compareTo("0") == 0){	
	    String Login = Req.getParameterValues("login")[0];
	    String Pass = Req.getParameterValues("pass")[0];
	    // Validating the entry
	    Validator myValidator = new Validator();
	    String usertype = myValidator.Validate(Req,Mycon);
	    // Checking the User type
	    System.out.println(usertype);
	    if(usertype.compareTo("student") == 0){
		ss = new StudentSession();
	        System.out.println("In student session");
	    }
	    else if(usertype.compareTo("faculty") == 0){
		ss = new FacultySession();
	        System.out.println("In faculty session");
	    }
	    else if(usertype.compareTo("root") == 0){
		ss = new RootSession();
	        System.out.println("In root session");
	    }
	    else{
		ss = new AuthFailSession();
	    }
	    hs.putValue("mySession",ss);
	    ss.loginId=Login;
	    ss.password=Pass;
	    // Printing back the corresponding Page
    	    ss.printPage(Mycon,out,Req,Id);
	}
	else{
	    ss.processData(Req,Mycon,out);
    	    ss.printPage(Mycon,out,Req,Id);
	    out.close();
	}
    }
}
