import java.io.*;
import java.lang.*;
import java.lang.Math;
import java.util.*;
import java.util.Date;
import java.sql.*;
import javax.servlet.*;
import javax.servlet.http.*;

public class RootSession extends Session{
	
    String Dir="/users/ug96/gsiva/6_sem/Bis/Bis_project/Java_codes/Html_files/";
	
    public void printPage(Connection Mycon,PrintWriter out,HttpServletRequest Req,String cook){
	// Read from the corresponding form and print back!!!
	try{
	    Integer form_no = new Integer(Req.getParameterValues("form_no")[0]);
	    switch(form_no.intValue()){
		case 0:
		    this.printRespectivePage(Dir+"Rootpage.html",out);
		    break;
		case 1:
		    this.printMembersPage(Mycon,out);
		    break;
		case 2:
		    this.printRespectivePage(Dir+"insert_type.html",out);
		    break;
		case 3:
		    this.printRelationPage(Mycon,out);
		    break;
	    }
	} catch(NumberFormatException e){}
	  catch(FileNotFoundException e){}
	  catch(IOException e){}
    }

    public void printMembersPage(Connection Conn,PrintWriter out){
	try{
	String s="";
        this.printRespectivePage(Dir+"insert_members1.html",out);
	Statement Stmt=Conn.createStatement();
	ResultSet depts=Stmt.executeQuery("select * from department");
	s+="<td><font size=5><select name=dept>";
	while(depts.next()){
		s+="<option value="+depts.getString(1)+">"+depts.getString(2);
	}
	s+="</select></font></td>";
	out.println(s);
        this.printRespectivePage(Dir+"insert_members2.html",out);
	} catch(SQLException e){}
	catch(FileNotFoundException e){} 
	catch(IOException e){}
    }	

    public void printRelationPage(Connection Conn,PrintWriter out){
	try{
	String s="";
        this.printRespectivePage(Dir+"insert_relation1.html",out);
	Statement Stmt=Conn.createStatement();
	ResultSet types=Stmt.executeQuery("select * from types");
	s+="<font size=5><select name=type>";
	while(types.next()){
		s+="<option value="+types.getString(1)+">"+types.getString(1).toUpperCase();
	}
	s+="</select></font>";
	out.println(s);
        this.printRespectivePage(Dir+"insert_relation2.html",out);
	} catch(SQLException e){} 
	catch(FileNotFoundException e){}
	catch(IOException e){}
    }	

    public void processData(HttpServletRequest Req,Connection Mycon,PrintWriter out){
	try{
	    Integer form_no = new Integer(Req.getParameterValues("form_no")[0]);
	    switch(form_no.intValue()){
		case 4:
			memberHandler(Req,Mycon);
		        this.printMembersPage(Mycon,out);
			break;
		case 5:
			typeHandler(Req,Mycon);
		        this.printRespectivePage(Dir+"insert_type.html",out);
			break;
		case 6:
			relationHandler(Req,Mycon);
		        this.printRelationPage(Mycon,out);
			break;
		case 7:
			printMembers(out,Mycon);
			break;
		case 8:
			printTypes(out,Mycon);
			break;
		case 9:
			printRelations(out,Mycon);
			break;
	    }
	} catch(NumberFormatException e){}
	  catch(FileNotFoundException e){}
	  catch(IOException e){}
    }
    

    public void relationHandler(HttpServletRequest req,Connection Conn){
	try{ 
	Statement Stmt=Conn.createStatement();
	String Ins="";
	if(req.getParameterValues("insert_delete")[0].compareTo("1")==0){
	     Ins="insert into student_faculty values('";
	     Ins+=this.checkQuote(req.getParameterValues("slogin")[0])+"','";
	     Ins+=this.checkQuote(req.getParameterValues("flogin")[0])+"','";
	     Ins+=this.checkQuote(req.getParameterValues("type")[0])+"','";
	     Ins+=this.checkQuote(req.getParameterValues("clogin")[0]);
	     Ins+="')";
  	     Stmt.executeUpdate(Ins);
	}
	else if(req.getParameterValues("insert_delete")[0].compareTo("2")==0){
	        Ins="delete from student_faculty where sroll='";
		Ins+=checkQuote(req.getParameterValues("slogin")[0])+"'";
		Ins+="and loginid='";
		Ins+=checkQuote(req.getParameterValues("flogin")[0])+"'";
		Ins+="and type='";
		Ins+=checkQuote(req.getParameterValues("type")[0])+"'";
		Stmt.executeUpdate(Ins);
	}
	}catch(SQLException e){}
    }	
    
    
    public void memberHandler(HttpServletRequest req,Connection Conn){
	try{ 
	Statement Stmt=Conn.createStatement();
	String Ins="";
	if(req.getParameterValues("insert_delete")[0].compareTo("1")==0){
	     Ins="insert into auth_table values('";
	     Ins+=this.checkQuote(req.getParameterValues("login")[0])+"','";
	     Ins+=this.checkQuote(req.getParameterValues("password")[0])+"','";
	     Ins+=this.checkQuote(req.getParameterValues("dept")[0])+"','";
	     Ins+=this.checkQuote(req.getParameterValues("member")[0]);
	     Ins+="')";
	     System.out.println(Ins);
  	     Stmt.executeUpdate(Ins);
	}
	else if(req.getParameterValues("insert_delete")[0].compareTo("2")==0){
	        Ins="delete from auth_table where login='"+checkQuote(req.getParameterValues("login")[0])+"'";
		Stmt.executeUpdate(Ins);
	}
	}catch(SQLException e){}
    }	
    
    public void printMembers(PrintWriter out,Connection Conn){
	try{    
	Statement Stmt=Conn.createStatement();
	String s="";
	out.println("<html> <body background=\"http://www.cse.iitb.ernet.in/~gsiva/green_pasture.gif\" text=yellow bgcolor=green link=\"#ffffff\"><head><h1><u><center>MEMBERS</center></u></h1></head>"); 
	
	ResultSet types=Stmt.executeQuery("select * from auth_table where type='student'");
	s+="<br><br><font size=5><center>STUDENTS<br>";
	while(types.next()){
	    s+="<font size=4><center>"+types.getString(1)+"  ";
	    s+=types.getString(3)+"  ";
	    s+=types.getString(4);
	    s+="</center></font><br>";
	}
	
	types=Stmt.executeQuery("select * from auth_table where type='faculty'");
	s+="<br><br><font size=5><center>FACULTY<br>";
	while(types.next()){
	    s+="<font size=4><center>"+types.getString(1).toUpperCase()+"  ";
	    s+=types.getString(3).toUpperCase()+"  ";
	    s+=types.getString(4).toUpperCase();
	    s+="</center></font><br>";
	}
	
	types=Stmt.executeQuery("select * from auth_table where type='root'");
	s+="<br><br><font size=5><center>ROOT<br>";
	while(types.next()){
	    s+="<font size=4><center>"+types.getString(1).toUpperCase()+"  ";
	    s+=types.getString(3).toUpperCase()+"  ";
	    s+=types.getString(4).toUpperCase();
	    s+="</center></font><br>";
	}
	
	s+="</body></html>";
	out.println(s);
	} catch(SQLException e){} 
    }	

    public void printTypes(PrintWriter out,Connection Conn){
	try{    
	Statement Stmt=Conn.createStatement();
	String s="";
	out.println("<html> <body background=\"http://www.cse.iitb.ernet.in/~gsiva/green_pasture.gif\" text=yellow bgcolor=green link=\"#ffffff\"><head><h1><u><center>TYPES</center></u></h1></head>"); 
	ResultSet types=Stmt.executeQuery("select * from types");
	while(types.next()){
	    s+="<font size=5><center>"+types.getString(1);
	    s+="</center></font><br>";
	}
	s+="</body></html>";
	out.println(s);
	} catch(SQLException e){} 
    }	
    
    public void printRelations(PrintWriter out,Connection Conn){
	try{    
	Statement Stmt=Conn.createStatement();
	String s="";
	out.println("<html> <body background=\"http://www.cse.iitb.ernet.in/~gsiva/green_pasture.gif\" text=yellow bgcolor=green link=\"#ffffff\"><head><h1><u><center>RELATIONS</center></u></h1></head>"); 
	ResultSet types=Stmt.executeQuery("select * from student_faculty");
	s+="<center><table>";
	s+="<tr><td>Student</td><td>Guide</td><td>Co Guide</td>";
	while(types.next()){
	    s+="<tr><td><font size=5>"+types.getString(1);
	    s+="</font>";
	    s+="<td><font size=5>"+types.getString(2);
	    s+="</font>";
	    s+="<td><font size=5>"+types.getString(4);
	    s+="</font>";
	}
	s+="</table></center>";
	s+="</body></html>";
	out.println(s);
	} catch(SQLException e){} 
    }	

    public void typeHandler(HttpServletRequest req,Connection Conn){
	try{ 
	Statement Stmt=Conn.createStatement();
	String Ins="";
	if(req.getParameterValues("insert_delete")[0].compareTo("1")==0){
	        Ins="insert into types values('"+this.checkQuote(req.getParameterValues("type")[0])+"')";
		Stmt.executeUpdate(Ins);
	}
	else if(req.getParameterValues("insert_delete")[0].compareTo("2")==0){
	        Ins="delete from types where type='"+checkQuote(req.getParameterValues("type")[0])+"'";
		Stmt.executeUpdate(Ins);
	}
	}catch(SQLException e){}
    }	

    public void printRespectivePage(String Filename,PrintWriter out)
    throws FileNotFoundException,IOException{
	// Open the file with name Filename and just print the contents of it!! 

	try{
	    System.out.println("I in printrespage and file name="+Filename);
            FileInputStream file = new FileInputStream(Filename);
	    InputStreamReader reader = new InputStreamReader(file);
	    BufferedReader input = new BufferedReader(reader);
	    String nextLine;
	    while((nextLine=input.readLine())!=null){
	        out.println(nextLine);
	    }
	    input.close();
	    reader.close();
	    file.close();
	} catch(FileNotFoundException e){System.out.println("File not found");}
    }

    String checkQuote(String initString){
	int beginindex=0,endindex=0;
	String returnString="";
	for(;;){
	    endindex=initString.indexOf("'",beginindex);
	    if(endindex==-1){
		returnString+=initString.substring(beginindex);
		break;
	    }
	    else{
		returnString+=initString.substring(beginindex,endindex)+"''";
		beginindex=endindex+1;
	    }
    	}
	return(returnString);
    }	
}
